org.apache.struts2.jasper.compiler.tagplugin

## Interface TagPluginContext

-     public interface TagPluginContext

  This interface allows the plugin author to make inqueries about the properties of the current tag, and to use Jasper resources to generate direct Java codes in place of tag handler invocations.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `dontUseTagPlugin()` Abandon optimization for this tag handler, and instruct Jasper to generate the tag handler calls, as usual.
    `void` | `generateAttribute(String attribute)` Generate codesto evaluate value of a attribute in the custom tag The codes is a Java expression.
    `void` | `generateBody()` Generate codes for the body of the custom tag
    `void` | `generateDeclaration(String id, String text)` Generate a declaration in the of the generated class.
    `void` | `generateImport(String s)` Generate an import statement
    `void` | `generateJavaSource(String s)` Generate Java source codes
    `String` | `getConstantAttribute(String attribute)`
    `TagPluginContext` | `getParentContext()` Get the PluginContext for the parent of this custom tag.
    `Object` | `getPluginAttribute(String attr)`
    `String` | `getTemporaryVariableName()`
    `boolean` | `isAttributeSpecified(String attribute)`
    `boolean` | `isConstantAttribute(String attribute)`
    `boolean` | `isScriptless()`
    `void` | `setPluginAttribute(String attr, Object value)` Associate the attribute with a value in the current tagplugin context.

- - ### Method Detail

    - #### isScriptless

          boolean isScriptless()

      Returns:
        true if the body of the tag is scriptless.

    - #### isAttributeSpecified

          boolean isAttributeSpecified(String attribute)

      Parameters:
        `attribute` - Name of the attribute
      Returns:
        true if the attribute is specified in the tag

    - #### getTemporaryVariableName

          String getTemporaryVariableName()

      Returns:
        An unique temporary variable name that the plugin can use.

    - #### generateImport

          void generateImport(String s)

      Generate an import statement
      Parameters:
        `s` - Name of the import class, '*' allowed.

    - #### generateDeclaration

          void generateDeclaration(String id,
                                   String text)

      Generate a declaration in the of the generated class. This can be used to declare an innter class, a method, or a class variable.
      Parameters:
        `id` - An unique ID identifying the declaration. It is not part of the declaration, and is used to ensure that the declaration will only appear once. If this method is invoked with the same id more than once in the translation unit, only the first declaration will be taken.
        `text` - The text of the declaration.

    - #### generateJavaSource

          void generateJavaSource(String s)

      Generate Java source codes
      Parameters:
        `s` - string

    - #### isConstantAttribute

          boolean isConstantAttribute(String attribute)

      Parameters:
        `attribute` - the attribute to check
      Returns:
        true if the attribute is specified and its value is a translation-time constant.

    - #### getConstantAttribute

          String getConstantAttribute(String attribute)

      Parameters:
        `attribute` - The specified attribute
      Returns:
        A string that is the value of a constant attribute. Undefined if the attribute is not a (translation-time) constant. null if the attribute is not specified.

    - #### generateAttribute

          void generateAttribute(String attribute)

      Generate codesto evaluate value of a attribute in the custom tag The codes is a Java expression. NOTE: Currently cannot handle attributes that are fragments.
      Parameters:
        `attribute` - The specified attribute

    - #### generateBody

          void generateBody()

      Generate codes for the body of the custom tag

    - #### dontUseTagPlugin

          void dontUseTagPlugin()

      Abandon optimization for this tag handler, and instruct Jasper to generate the tag handler calls, as usual. Should be invoked if errors are detected, or when the tag body is deemed too compilicated for optimization.

    - #### getParentContext

          TagPluginContext getParentContext()

      Get the PluginContext for the parent of this custom tag. NOTE: The operations available for PluginContext so obtained is limited to getPluginAttribute and setPluginAttribute, and queries (e.g. isScriptless(). There should be no calls to generate*().
      Returns:
        The pluginContext for the parent node. null if the parent is not a custom tag, or if the pluginConxt if not available (because useTagPlugin is false, e.g).

    - #### setPluginAttribute

          void setPluginAttribute(String attr,
                                  Object value)

      Associate the attribute with a value in the current tagplugin context. The plugin attributes can be used for communication among tags that must work together as a group. See <c:when> for an example.
      Parameters:
        `attr` - The specified attribute
        `value` - the value

    - #### getPluginAttribute

          Object getPluginAttribute(String attr)

      Parameters:
        `attr` - The specified attribute
      Returns:
        the value of an attribute in the current tagplugin context.

Copyright © 2000–2024 Apache Software Foundation. All rights reserved.